.nolist
include \masm32\include\masm32rt.inc
include \masm32\fpulib\fpu.inc
includelib \masm32\fpulib\fpu.lib
.686
include \masm32\macros\timers.asm

; various options for testing -----------------------------------------------------------------------
UseInit =	1	; 0: don't, 1: do use FPU finit at start of tests
Store8ToFPU =	1	; store 8 values in FPU registers to check for register preservation
SpeedTest =	1	; 0: no timings, set to 0 for fast testing of macros etc
MyTest =	1	; various float tests (double minus not ok)
LoopFast =	1	; put 1 for speeding up things
f2Test =	1	; LittleTest
ShowMacro =	1	; show examples of macro use
; ------------------------------------------------------------------------------------------------------------------

dwtoaX	PROTO: DWORD, :DWORD
FS_sprintf	PROTO: DWORD, :DWORD	; crt_sprintf
FloatToStrX	PROTO: QWORD, :PTR CHAR	; copy of MasmLib FloatToStr

; new float to string conversion procedure, for use with float$ macro
FloatStr	PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
;Float2Asc	PROTO: DWORD, :DWORD

CopyMem	PROTO: DWORD, :DWORD, :DWORD	; GeneSys
CopyPop	PROTO: DWORD, :DWORD, :DWORD	; GeneSys

TestNum MACRO tproc:REQ, testnum:REQ
LOCAL tmp$
	tmp$ CATSTR <">,<testnum>,<">
;	print chr$(tmp$, 9)
  if Store8ToFPU
	call LoadFPU
  endif
  if tproc eq 0
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke FloatToStrX, testnum, addr f2sBuffer
		; int 3	; discards ST 6, 7, 8
	counter_end
	print ustr$(eax)," cycles for FloatToStr", 9
	print offset f2sBuffer, 13, 10

  elseif tproc eq 1
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		if ChkNum(testnum) eq 2			;; Real8, use standard invoke
			invoke Float2Asc, 0, addr testnum
		else
			mov eax, float$(testnum)	;; other
		endif
		; int 3	; to test whether ST registers are intact (they are ;-)
	counter_end
	if ArgSize eq 4	;; 4 for DWORD, 10 for REAL10, 99 for immediate and reg
		tmp$ CATSTR <" cycles for float$ >, <testnum>,<">
	else
		; tmp$ CATSTR <" cycles for float$ Real>, %ArgSize, <">
		tmp$ CATSTR <" cycles for float$ >, t$, <">
	endif
	% print ustr$(eax), tmp$, 9
	print offset f2sBuffer, 13, 10

  elseif tproc eq 3
  	if 0
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		push offset f2sBuffer
		mov eax, offset testnum
		push [eax+4]
		push [eax]
		call R8ToStr
	counter_end
	print ustr$(eax)," cycles for R8ToStr    ", 9
	print offset f2sBuffer, 13, 10
	endif
  elseif tproc eq 2
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov edx, offset testnum
		call F2sRay
		; int 3	; to test whether ST registers are intact
	counter_end
	print ustr$(eax)," cycles for Ray's lib", 9
	mov edx, offset f2sBuffer
	mov al, [edx]
	.if al==32
		inc edx
	.endif
	print edx, 13, 10

  else
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		INVOKE crt_sprintf, ADDR f2sBuffer, ADDR sprintFormat, testnum
		; int 3	; to test whether ST registers are intact
	counter_end
	print ustr$(eax)," cycles for sprintf  ", 9
	print offset f2sBuffer, 13, 10

  endif
ENDM
; click to the right to create Float2Asc.inc	;$rl click [url=#Float2Asc.inc=\masm32\include\Float2Asc.inc]here[/url]
; ----------------------------------------------------------------------------------------------------------------------- 
Float2Asc	PROTO: DWORD, :DWORD

f2sPrec =	7	; ->f2sDigits; max 16-18 digits (7 is default for FloatToStr); see also f2sSeed
SwScNot =	-3	; if exponent < n, switch to scientific notation
ExRange equ	150	; range ca. e-150...e+150
signed	equ sdword ptr 
; --------------------------------------------------------------
; yields info how to push arg on FPU, and the argument to pass
; 4	Int32, reg32, reg16, reg8, immediate32
; 5	Real4	(called as @MyReal4)
; 8	Real 8	(also immediate real number)
; 10	Real10

ChkNum MACRO argX:REQ
LOCAL ArgType, tmp$, arg, nu8, dot, deco
  aPass$ equ <0>					;; several times redefined, no problem...!
  arg equ <argX>					;; sizes: 0=fild, 1=R4, 2=R8, 3=R10
  NumSize = -1					;; global return value, -1=error
  ifb <argX>
	crash
	EXITM <0>					;; no argument passed
  endif
  dot INSTR arg, < >				;; leading space?
  if dot eq 1
	arg SUBSTR arg, 2			;; strip one leading space
  endif
  dot INSTR arg, < >				;; leading space?
  if dot
	arg SUBSTR arg, 1, dot-1		;; strip trailing spaces
  endif
  dot INSTR arg, <.>				;; immediate real?
  deco INSTR arg, <@>			;; REAL4, size 4 but decorated?
  if deco eq 0
	deco INSTR arg, <eal4>		;; dirty hack for TestNum
  endif
  ;tmp$ CATSTR <t=>,<arg>, <, hasdot=>, %dot, <, hasdeco=>, %deco
  ;% echo tmp$
  if deco
  	if deco eq 1						;; to distinguish Real4 from Int32,
		arg SUBSTR arg, 2			;; we decorate with a @
		;% echo <arg> was decorated
	endif
	NumSize = 1				;; REAL4
	ArgType = (opattr(arg)) AND 127
	if ArgType eq atLocal
		t$ CATSTR <lea eax, >, <arg>
		t$
		aPass$ equ eax			;; eax will be trashed when using a LOCAL
		t$ equ <Local REAL4>
	else
		aPass$ CATSTR <offset >, <arg>
		t$ equ <REAL4>
	endif
  elseif dot
	.data
		nu8 REAL8 arg			;; write arg to .DATA section
	.code
	NumSize = 2				;; Real8
	aPass$ equ <offset nu8>	;; we pass it as a pointer to the new Real8
	t$ equ <immediate Real8>
  else								;; none of the above
	ArgType = (opattr(arg)) AND 127			;; 0 no vn$, 36 immediate, 42 global, 48 CPU register, 98 local
	if ArgType eq atLocal or ArgType eq atGlobal
		RealSize = SIZEOF arg	;; 4 for DWORD, 10 for REAL10
		if RealSize eq 4
			NumSize = 0	;; Integer
			tmp$ CATSTR <mov eax, >, <arg>
			;% echo tmp$
			tmp$				;; insert code
			aPass$ equ eax		;; eax will be trashed
			t$ equ <Int32>
			;% echo t$
			;% echo aPass$
			;echo
		else
			if ArgType eq atLocal
				tmp$ CATSTR <lea eax, >, <arg>
				tmp$				;; insert lea code (instead of addr)
				aPass$ equ eax		;; eax will be trashed when using a LOCAL
			else
				aPass$ CATSTR <offset >, <arg>
			endif
			if RealSize eq 8
				NumSize = 2	;; Real8
				t$ equ <REAL8>
			elseif RealSize eq 10
				NumSize = 3	;; Real10
				t$ equ <REAL10>
			else
				echo Size %RealSize no good, sorry
				.err
			endif
		endif
	elseif ArgType eq atImmediate
;		tmp$ CATSTR <Immediate passed: >, arg
;		% echo tmp$
		NumSize = 0			;; immediate integer
		tmp$ CATSTR <mov eax, >, <arg>
		tmp$
		aPass$ equ eax			;; push it using eax
		t$ equ <immediate DWORD>
	elseif ArgType eq atRegister
		RealSize SIZESTR arg
		NumSize = 0			;; register as int32
		if RealSize eq 3			;; full size register
			aPass$ equ arg		;; push it "as is"
			t$ equ <DWORD reg>
		else
;			% echo checking register for <arg>
			t$ SUBSTR arg, 1, 1		;; e.g. ax, ah, el, cx
;			% echo t$
			tmp$ CATSTR <movzx e>,t$, <x, >, <arg>
;			% echo tmp$
			tmp$	; insert code, e.g. movzx ecx, cl
			aPass$ CATSTR <e>, t$, <x>	; ecx etc
;			% echo aPass$
			dot INSTR arg, <x>
			;tmp$ CATSTR <dooot >,%dot, < for >, arg
			;% echo tmp$
			if dot eq 0
				t$ equ <BYTE reg>
			else
				t$ equ <WORD reg>
			endif
;			% echo t$

		endif
	endif
  endif
  if NumSize lt 0
	 tmp$ catstr arg, < is >, %ArgType, <, with size >, %NumSize
	% echo tmp$
	.err
  endif
  EXITM <NumSize>
ENDM

;     OPATTR guide
;     Bit	Set If...
;     0	References a code label
;     1	Is a memory expression or has a relocatable data label
;     2	Is an immediate expression
;     3	Uses direct memory addressing, i.e. is an absolute memory reference
;     4	Is a register expression
;     5	References no undefined symbols and is without error
;     6	References a stack location (usually a LOCAL variable or parameter)
;     7	References an external label
;     8-10	Language type (0=no type)
		; 76543210
atImmediate	equ 36	; 00100100
atGlobal	equ 42	; 00101010
atRegister	equ 48	; 00110000
atLocal	equ 98	; 01100010

float$ MACRO strformat, num	;; example: print float$("\nMy number is %f", MyReal8)
LOCAL P$, PP, PP_o, parseLen, c$, co$, AriMode, AriMult, CurAri, LastAri, NegFlag, CurNum$, argct, slot$, aSize1, HasDot
LOCAL f2sMS, ArgType, atyB, asiB, tmp$, quotes, arg1a, arg2a, arg3a, arg4a, mode$, FF$, nustr
LOCAL aPass1, aPass2, aPass3, aPass4	; ArgSize global for TestNum
  mov edx, offset f2sSlots
  HasDot	= 0	;; immediate reals, 1.234e44
  NegFlag	= 0	;; if a para starts with -
  f2sMS	= 0	;; combined mode and size parameter
  argct	= 0	;; argument counter (4 num args max)
  PP	= 0	;; startpos in parse$
  PP_o	= 1	;; ParsePos old
  ; ArgSize =	0	;; for TestNum
  ; AriMode =	0	;; arithmetic mode
  LastAri =	0	;; prev mode, e.g. 123+MyInt* when * is found
  AriMult =	1	;; ari multiplier
  FF$ equ	<0>	;; FloatFormat$: if 0, just print the number
  quotes	INSTR <strformat>, <">
  if quotes eq 0
	quotes	INSTR <strformat>, <'>
  endif
  if quotes eq 1
	P$ CATSTR <num>, <>		;; first arg is a format string
	FF$ equ <offset nustr>		;; we pass it as FF$
	.data
		nustr db strformat, 0		;; write arg to .DATA section
	.code
  else
	P$	CATSTR <strformat>, <>	;; first arg is not format but the number itself
  endif
 
  parseLen SIZESTR P$

; tmp$ CATSTR <We scan >, P$, <, >, %parseLen, < bytes>
; % echo tmp$

  WHILE PP lt parseLen	; Repeat until Parse Position >= LEN(P$)
	PP=PP+1	; Position in Parse$
	c$ SUBSTR P$,PP,1
	CurAri INSTR <+-*/.eE>, c$	; 1234; and 8: neg before continuing
	if CurAri eq 2
		if PP eq PP_o
			NegFlag=32
			CurAri=0
			PP_o=PP+1
			tmp$ CATSTR <MINUS: pp=>, %PP, <, ppo=>, %PP_o
			% echo tmp$
		endif
	endif
	if CurAri eq 6
		HasDot = 1
		;% echo ThisStringHasDot: <P$>
		CurAri = 0
	endif
	if CurAri gt 6
		CurAri = 0
		tmp$ SUBSTR P$, 1, PP
		if HasDot
			PP = PP + 1	;; skip 123e+1
			;tmp$ CATSTR <We skipped >, tmp$
		;else
			;tmp$ CATSTR <NO DOT in >, tmp$
		endif
		;% echo tmp$
	endif
	if CurAri
		CurNum$ SUBSTR P$,PP_o,PP-PP_o
;		tmp$ CATSTR <t=x>,CurNum$, <x, P1=>, %PP, <, P2=>, %PP_o
;		% echo tmp$
		CurMS = LastAri + 8 * ChkNum(CurNum$)+NegFlag
;		tmp$ CATSTR <CurMSize=>, %CurMS, <, of which ari=>, %LastAri
;		% echo tmp$
		f2sMS = f2sMS + AriMult * CurMS	;; mode (bits 0-2, 0-7) and NumSize (bits 3-5, 8*(0-3), bit 6 reserved for NegFlag)
		LastAri = CurAri
		NegFlag = 0		;; clear the flag
;		tmp$ CATSTR <We pass >, aPass$
;		% echo tmp$

		mov [edx], aPass$
		add edx, 4
		; echo done

		;tmp$ CATSTR <ModeSize=>, %f2sMS
		;% echo tmp$
		AriMult = AriMult * 64		;; 5*6=30: 0...7 sizes: 0=fild, 1=R4, 2=R8, 3=R10, 0...7 ari, 8=neg 000 001 010 011 100 101 110 111
		; % aPass1 equ aPass$
		if argct
			slot$ CATSTR <mov [edx+>, %argct*4, <], >, aPass$
		else
			slot$ CATSTR <mov [edx], >, aPass$
			ArgSize = NumSize		;; for TestNum
		endif
		argct = argct + 1
		if argct eq 6
			echo too many arguments
			.err
		endif
		PP_o = PP+1
		HasDot = 0
		;% echo slot$
		;echo
	endif
  ENDM
  % invoke Float2Asc, FF$, f2sMS

; slot 0 taken: it's float$; FF$ or 0, f2sMS, slot 0: arg0, slot 1: arg1 etc
; slots not taken: FF$ or 0, Real8
 ;  invoke FloatStr: 0 or 100, addr x = Real10, 40, addr x = Real4, 80, addr x = Real8, addr FF$, addr x = Real8
 ;  invoke FloatStr: n, FF$ for macro invokes with n=1-4
  EXITM <eax>
ENDM

.data?
f2sTmpBuf	dd 10 dup(?)	; internal buffer for f2sForm$
f2sSlots	dd 6 dup(?)	; 5+1 for flagging last slot
f2sP10	REAL8 ExRange+5 dup(?)
f2sP10Mid	REAL8 ?
	REAL8 ExRange-1-5 dup(?)
f2sDummy	dw ?
f2sBuffer	dd 80 dup(?)	; returned by float$

.data
sprintFormat	db "%.7g", 0
align 4
f2sSeed	REAL10 1.000000000000000004e+156
;f2sSeed	@CatStr(<REAL10 1.00000000000000001e+>,%ExRange+6)
f2s0dot1	REAL10	0.1
f2sRnd05	REAL8	0.5		; a for dwtoa

.code
Float2Asc proc	f2sForm$:DWORD,		; pointer to e.g. "The relation A:B is %f"
	f2sMS:DWORD		; pointer to ModeSize or to first number
LOCAL f2sTmp64:QWORD
LOCAL f2sST0:REAL10, f2sST1:REAL10, f2sST2:REAL10
LOCAL f2sDigits:DWORD
LOCAL f2sExpo:DWORD
LOCAL f2sConWold:WORD, f2sConW:WORD

COMMENT @ ------------------------------------------------------------------------------------------------------
This routine should be called through the float$ macro, so that
the appropriate size can be chosen. The use without this macro
is restricted to REAL8 variables, passed as follows:

	invoke Float2Asc, chr$("\nA test: %f\n\n"), addr MyReal8
	MsgBox 0, eax, "Float test:", MB_OK

	print rv(Float2Asc, chr$("\nA test: %f\n\n"), offset MyReal8)

	print rv(Float2Asc, 0, offset MyReal8)		; prints the plain number

--------	jj2007 September 2008 - use at your own risk --------------------------------------------- @
	push ebx	; save regs
	push edi
	push esi
	mov f2sDigits, f2sPrec			; default
	mov esi, offset f2sBuffer
	mov edi, f2sForm$				; do we have a string  la "The number %f is too small"?
	.if edi
			xor eax, eax
	@@:	mov al, [edi]			; xxx we copy the format string to the output buffer
			test eax, eax
			je @F
			cmp al, "%"
			je @F					; insert number: we are done here

			mov cx, [edi]
			cmp cx, "t\"				; tab?
			jne NoTab
			sub eax, 92-9			; mov al, 9
			inc edi
			jmp NoLf

	NoTab:	cmp cx, "n\"				; newline?
			jne NoLf
			sub eax, 92-13			; mov al, 13
			mov [esi], al
			inc esi
			inc edi
			sub eax, 3				; mov al, 10

	NoLf:	mov [esi], al
			inc edi
			inc esi
			jmp @B

	@@:	mov al, [edi+1]
			.if byte ptr al>"0"
				.if byte ptr al<="9"		; Uppercase F = 15
					and al, 15
					inc edi
					mov f2sDigits, eax	; change precision
				.elseif byte ptr al<="J"	; Uppercase F = 15, K=20
					sub al, 55
					inc edi
					mov f2sDigits, eax	; change precision
				.endif
			.endif
			mov f2sForm$, edi	; we'll do the rest after we are finished ...
	.endif						; ... with the number, starting from current esi
	mov edx, offset f2sP10		; v v interleaving saves ca. 5 cycles
	mov ecx, [edx]
	.if ecx==0
		fclex					; clear exceptions; 34 cycles, so we do it only once
	.endif
	fstcw f2sConWold			; status word could be saved as fstsw ax,
	mov ax, f2sConWold		; but no such instruction for Control word
	or ax, 011100000000b		; rounding mode DOWN,
	mov f2sConW, ax			; precision max=64
	fldcw f2sConW				; set new control word
	fstp f2sST0					; save & free 3 registers: 3*(6+6)=36 cycles, in practice 10 per FPU register, 30 cycles
	fstp f2sST1					; No. 2 saved
	mov edi, offset f2sSlots
	fstp f2sST2					; No. 3 saved

	.if ecx==0
		fld f2s0dot1				; ------- create multplier table --------
		fld f2sSeed
		;int 3
		mov ecx, ExRange*2
	@@:
		fmul st, st(1)
		fst REAL8 ptr [edx]		; f2sP10
		add edx, 8
		dec ecx
		jne @B
		fstp st					; pop 2 registers, old
		fstp st					; ST0 will be on top again
	.endif

; slot 0 taken: it's float$; FF$ or 0, f2sMS, slot 0: arg0, slot 1: arg1 etc
; slots not taken: FF$ or 0, Real8
	mov ebx, f2sMS			; slots taken: AriMode + 8 * Size+ 32 * NegFlag
	mov edx, [edi]				; mov edi moved up for interleaving
	.if edx
		; ************************	  macro mode   *******************************************
NxtSlot:	mov ecx, ebx			; mode & size
		sar ecx, 3
		and ecx, 3				; size only
		.if cl==2
			fld REAL8 ptr [edx]		; load from mem, 3 cycles
		.elseif cl==3
			fld REAL10 ptr [edx]		; load from mem, 6 cycles
		.elseif cl==1
			fld REAL4 ptr [edx]		; load from mem, 3 cycles
		.elseif cl==0
			fild dword ptr [edi]		; push the integer in edx=[edi] (reg or immediate)
		.endif
		mov eax, ebx				; mode
		test eax, 32
		je @F
		fchs					; NegFlag: change sign
@@:		and eax, 7				; mode only
		.if eax
			.if al==1	
				fadd
			.elseif al==2
				fsub
			.elseif al==3
				fmul
			.elseif al==4
				fdiv
			.endif
		.endif
		xor ecx, ecx
		mov [edi], ecx			; flag old slot empty for next invoke
		add edi, 4
		mov edx, [edi]
		sar ebx, 6				; get next 6 bits for size and mode
		test edx, edx
		jne NxtSlot				; slot empty, so outta here
		; ************************	  end of macro slots  ******************************************
	.else
		fld REAL8 ptr [ebx]		; "normal" invoke instead of macro, load from mem=3 cycles
	.endif
	xor ecx, ecx					; sign flag
	ftst							; test for zero
	mov edi, esi				; we want to insert the number into edi
	fstsw ax
	sahf
	je f2sZero					; 0.0
	jnc f2sPos					; above zero
	mov al, "-"
	fabs						; our number is negative
	mov [edi], al
	inc edi						; edi=start of abs(num)

f2sPos:
	fldlg2						; load constant, 8 cycles
	fld st(1)						; store current number in FPU
;	.if MyInt3
;		int 3
;	.endif
	fyl2x						; log, 196-329 cycles
	fistp f2sExpo				; pop log10(num), i.e. exponent
	mov esi, f2sExpo			; exponent
	mov eax, esi
	sub eax, f2sDigits							; eax is log10, subtract digits to get multiplier
	lea edx, [f2sP10+8*eax+8*(ExRange+6)]	; max precision is 8*2=16	
	fld REAL8 ptr [edx]							; multiply the original number by 1.0 Exx
;	12 digits, expo=9, d=+3: esi=edi+9
;	12 digits, expo=15, d=-3: esi=edi+1, flag sci on
;	12 digits, expo=-1, d=-13: esi=edi+1, flag sci on

	.if signed esi>=0			; esi=f2sExpo
		.if esi>=f2sDigits
			xor esi, esi			; can't fit, so choose SciNot
		.endif
	.elseif signed esi>=SwScNot	; ------------- insert leading zeros ------------- v v
		mov al, "." 
		mov [edi+1], al			; Ascii 46 at pos 1
		add al, 2
		stosb					; mov [edi], al + inc edi: Ascii 48 at pos 0, i.e. leading 0
		mov edx, esi
		.While signed edx<-1	; write some zeros
			inc edi
			inc edx
			mov [edi], al
		.Endw
		or esi, -1				; no other dots please
	.else						; ------------- insert leading zeros ------------- ^ ^
		xor esi, esi				; can't fit, so choose SciNot
	.endif
	; int 3
	fmul						; normalise to a positive number (16 cycles)
	mov ebx, esi				; flag SciNot
	fld f2sRnd05				; 0.5 - the three instructions cost roughly 3 cycles
	fadd st(1),st					; round the integer upwards by adding 0.5, move result to st(1)
	fstp st						; pop ST

	mov eax, f2sDigits			; ----------- check for rounding 9.99999 problem ----
	neg eax
	lea edx, [f2sP10+8*eax+8*ExRange+8*5]	; get expected value from table
	fld REAL8 ptr [edx]							; load into FPU
	fsubr st, st(1)				; subtract current number
	ftst							; set flags
	fstsw ax					; pop flags
	sahf						; translate
	fstp st
	jb @F						; below: OK
	.if esi
		inc edi					; no SciNo: leave it there but move one dot to the right
	.else
		inc f2sDigits			; SciNo: fake a multiply by ten
		inc f2sExpo
	.endif						; ----------- rounding corrected ---------------------------------

@@:	add esi, edi					; pos to insert the dot, if any
	inc esi
	fistp f2sTmp64				; qword to mem
	lea eax, f2sTmp64			; address to dword to convert
	add edi, f2sDigits			; edi is pointer to end of output buffer
	call qw2Str				; convert to Ascii
	inc edi
	.if ebx==0					; use scientific notation ...
		mov ecx, f2sExpo			 ; ... only if exponent <> 0
		.if ecx
			mov eax, "0+e"				; default
			.if signed ecx<SwScNot		; jge ...
				neg ecx
				add ah, 2				; = mov eax, "0-e"
			.endif
			mov [edi], eax				; +-e0
			mov eax, ecx
			m2m ebx, 10
			xor edx, edx				; for div, edx must be zero
			div ebx						; result in eax, remainder in edx
			add dl, 30h					; last number of exponent
			add edi, 2
			mov [edi+1], dl
			.if signed ecx>=100			; we need less space for the expo
				mov [edi+2], dl			; 96/10=9 in eax, 6 in edx
				xor edx, edx			; for div, edx must be zero
				div ebx					; divide eax by 10 again
				add al, 30h
				stosb					; 1 in eax to left (mov [edi], al+inc edi)
				mov al, dl				; 2 in edx to middle position
			.endif
			add al, 30h
			mov esi, edi
			stosb					;mov [edi], al, inc edi
			inc edi
		.endif
	.endif
	mov byte ptr [edi], 0				; zero delimiter
f2sDone:								; ------------	xxx finish the job  ------------------------
	mov esi, f2sForm$				; did the format string have text after the number?
	.if esi
			inc esi					; get rid of %f
	@@:	inc esi					; v v -------------
			mov al, [esi]
			test al, al
			je @F

			mov cx, [esi]
			cmp cx, "t\"				; tab?
			jne NoT2
			sub eax, 92-9			; mov al, 9
			inc esi
			jmp NoLf2

	NoT2:	cmp cx, "n\"			; newline?
			jne NoLf2
			sub eax, 92-13			; mov al, 13
			stosb
			inc esi
			sub eax, 3				; mov al, 10

	NoLf2:	stosb					;mov [edi], al + inc edi
			jmp @B					; ^ ^ -------------

	@@:	stosb					; mov [edi], al + inc edi
	.endif
	fld f2sST2				; restore 3 registers
	pop esi					; xxx restore regs
	fld f2sST1
	pop edi
	fld f2sST0
	pop ebx
	fldcw f2sConWold		; restore control word
	mov eax, offset f2sBuffer
  ret

f2sZero:
	mov al, "0"
	stosb
	fstp st							; ST0 will be on top again
	jmp f2sDone

Float2Asc endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
qw2Str proc	; qw2Str needs ptr qword in eax, ptr buffer in edx
	push ebp			; credits to  [url=http://www.masm32.com/board/index.php?topic=9857.msg72422#msg72422]drizz[/url] 
	push edi
	push ebx
	push esi
	mov esi, [eax]
	add eax, 4		; 2 bytes longer but 2 cycles faster than mov edi, [eax+4
	mov ebp, edi		; buffer pointer - here passed as edi
	mov edi, [eax]
	test edi, edi		; is there a hi dword? depends on precision...
	jz @F

  @@U64Cvt:	; QWORD conversion loop
	mov eax, 0CCCCCCCDh	; = b0
	mul esi			; get a0*b0 = d1:d0
	mov eax, 0CCCCCCCDh	; = b0 (mov eax up saves 1 cycle)
	mov ecx, edx		; d1
	xor ebx, ebx
	mul edi			; get a1*b0 = e1:e0
	add ecx, eax		; e0
	adc ebx, edx		; e1
	mov eax, 0CCCCCCCCh	; =b1
	mul esi			; get a0*b1 = f1:f0
	add ecx, eax		; f0
	adc ebx, edx		; f1
	push 0			; 5 cycles faster, 3 bytes
	pop ecx			; shorter than mov ecx, 0
	mov eax, 0CCCCCCCCh	; =b1
	adc ecx, ecx
	mul edi			; get a1*b1 = g1:g0
	add eax, ebx		; g0
	adc edx, ecx		; g1
	shrd eax, edx, 3
	shr edx, 3			; ------ quotient in edx::eax

	; upper dwords will be the same after multiplication
	lea ecx, [eax*4+eax]	; ecx=5*eax
	neg ecx			; same speed, 2 bytes shorter
	lea ebx, [esi+2*ecx+"0"]
	mov esi, eax
	cmp ebp, [esp]		; 2 cycles, [esp]=esi
	je InsDot1		; 1 cycle
Dot1Ok:	mov [ebp], bl
	mov edi, edx
	sub ebp, 1		; dec ebp costs 1-2 cycles here
	test edi, edi
	jnz @@U64Cvt

  @@:	; we are here if HI-DWORD is 0
	mov eax, esi
	mov ebx, esi
	mov edi, 0CCCCCCCDh

	; Lower Dword conversion loop
  @@U32Cvt:	mul edi
	shr edx, 3
	lea ecx, [edx*4+edx]	; ecx=edx*5
	neg ecx			; 3 cycles faster
	lea ebx, [ebx+2*ecx+"0"]
	mov eax, edx		; sub ebx, mov eax 2 cycles faster than inverse sequence
	cmp ebp, [esp]		; 2 cycles
	je InsDot2		; 1 cycle
Dot2Ok:	mov [ebp], bl
	mov ebx, edx
	dec ebp			; sub ebp, 1 here a bit slower and 2 bytes more
	test eax, eax
	jnz @@U32Cvt

	pop esi
	pop ebx
	pop edi
	pop ebp
	ret
InsDot1:
	mov cl, "."		; ebx
	mov [ebp], cl
	dec ebp
	jmp Dot1Ok
InsDot2:
	mov cl, "."		; ebx
	mov [ebp], cl
	dec ebp
	jmp Dot2Ok

qw2Str endp
OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF
.const

;$rl ------------- end of Float2Asc.inc ------------------------

.data
MyReal4a	Real4	+1.23456789012345678e-5	; +6 still normal notation in sprintf
MyReal4b	Real4	+1.23456789012345678e-1	; -4 still normal notation in sprintf
MyReal4c	Real4	+1.23456789012345678e+0	; rule: >-4 or <precision JWASM: ...78+0 without the e not valid
MyReal4d	Real4	+1.23456789012345678e+3	; rule: >-4 or <precision
MyReal4e	Real4	+1.23456789012345678e+23
MyReal4f	Real4	 -1.23456789012345678e-23
MyReal4g	Real4	0.0

MyReal8a	REAL8	+1.23456789012345678e-7	; +6 still normal notation in sprintf
MyReal8b	REAL8	+1.23456789012345678e-1	; -4 still normal notation in sprintf
MyReal8c	REAL8	+1.23456789012345678e+0	; rule: >-4 or <precision
MyReal8d	REAL8	+1.23456789012345678e+3	; rule: >-4 or <precision
MyReal8e	Real8	+1.23456789012345678e+123
MyReal8f	Real8	 -1.23456789012345678e-123
MyReal8g	Real8	0.0

MyReal10a	Real10	+1.23456789012345678e-3	; +6 still normal notation in sprintf
MyReal10b	Real10	+1.23456789012345678e-1	; -4 still normal notation in sprintf
MyReal10c	Real10	+1.23456789012345678e+0	; rule: >-4 or <precision
MyReal10d	Real10	+1.23456789012345678e+3	; rule: >-4 or <precision
MyReal10e	Real10	+1.23456789012345678e+123
MyReal10f	Real10	 -1.23456789012345678e-123
MyReal10g	Real10	0.0

MyReal4	REAL4	1.234
MyPI10	REAL10	3.1415926535897932384626
MyReal	REAL4	1.234
MyInt4	dd	12345678

mta	REAL4	1234.5	; just for fun, we mix a real 4 with a real 10 for
mtb	REAL10	123.45	; calculating mta/mtb+113

Sales2006	REAL8 300.0
Sales2007	REAL8 309.6

; R10 for testing of formats - set SpeedTest = 0

R10a	REAL10	+1.234567890123456789e+20	; +6 still normal notation in sprintf	; MyInt3
R10b	REAL10	+1.234567890123456789e-20	; -4 still normal notation in sprintf
R10c	REAL10	+1.0e+20	; rule: >-4 or <no. precision digits
R10d	REAL10	+1.0e-20
R10e	REAL10	-1.0e+20
R10f	REAL10	-1.0e-20
R10g	REAL10	+8.99999999999999999e123
R10h	REAL10	+9.00000000000000001e123
R10i	REAL10	+9.99999999999999999e99	; 99->100	until 116 ok,
R10j	REAL10	 -9.99999999999999999e-101	; -101->100	but 118 fails...

;R10a	REAL10	+1.234567890123456789e+6	; +6 still normal notation in sprintf
;R10b	REAL10	-2.234567890123456789e-4	; -4 still normal notation in sprintf
;R10c	REAL10	+3.234567890123456789e-2	; rule: >-4 or <no. precision digits
;R10d	REAL10	-4.234567890123456789e0
;R10e	REAL10	+5.234567890123456789e4
;R10f	REAL10	-6.234567890123456789e8
;R10g	REAL10	+7.234567890123456789e12
;R10h	REAL10	-8.234567890123456789e14
;R10i	REAL10	+9.234567890123456789e123
;R10j	REAL10	-9.234567890123456789e-123

R10_Null	REAL10	0.0

; for debugging:
MyInt3	dd	0
; .if MyInt3
;	int 3
; .endif

;5575 cycles with xStr, Real10   -0.00022
;5235 cycles with xStr, Real10   0.032345
;5364 cycles with xStr, Real10   -4.23456
;5626 cycles with xStr, Real10   52345.67
;5414 cycles with xStr, Real10   -6.23456e+08
;5211 cycles with xStr, Real10   7.234567e+12
;4624 cycles with xStr, Real10   -8.23456e+14
;6646 cycles with xStr, Real10   9.234567e+123
;6350 cycles with xStr, Real10   -1.23456e-123

ten	dq	10.0

ten_1	dt	1.0e1
	dt	1.0e2
	dt	1.0e3
	dt	1.0e4
	dt	1.0e5
	dt	1.0e6
	dt	1.0e7
	dt	1.0e8
	dt	1.0e9
	dt	1.0e10
	dt	1.0e11
	dt	1.0e12
	dt	1.0e13
	dt	1.0e14
	dt	1.0e15

ten_16	dt	1.0e16
	dt	1.0e32
	dt	1.0e48
	dt	1.0e64
	dt	1.0e80
	dt	1.0e96
	dt	1.0e112
	dt	1.0e128
	dt	1.0e144
	dt	1.0e160
	dt	1.0e176
	dt	1.0e192
	dt	1.0e208
	dt	1.0e224
	dt	1.0e240

ten_256	dt	1.0e256
; The remaining exponents are only necessary if we decide to support
; 10-byte doubles.  FloatToStr and StrToFloat only support 8-byte,
; but PowerOf10 doesn't care, so we'll include them.
	dt	1.0e512
	dt	1.0e768
	dt	1.0e1024
	dt	1.0e1280
	dt	1.0e1536
	dt	1.0e1792
	dt	1.0e2048
	dt	1.0e2304
	dt	1.0e2560
	dt	1.0e2816
	dt	1.0e3072
	dt	1.0e3328
	dt	1.0e3584
	dt	1.0e4096
	dt	1.0e4352
	dt	1.0e4608
	dt	1.0e4864
tenX	dd	0

MyReal8	REAL8	1.2345678e9
MyReal10	REAL10	1.2345678e9

.code

start:	if UseInit
		finit		; a pretty slow instruction, so testing its performance might be useful
	endif
	if 0
	mov edi, 123
	mov esi, 456
	mov ebx, 789
			invoke FloatToStrX, MyReal8d, addr f2sBuffer
			print offset f2sBuffer, 13, 10
			invoke StrToFloat, addr f2sBuffer, addr MyReal8e	; [url=http://www.masm32.com/board/index.php?topic=9672.msg76611#msg76611]GM on Masm32[/url]
			print float$("\nNew Real8e=%f\n",MyReal8e)			; esi, edi, ebx not preserved
			print str$(edi), 13, 10
			print str$(esi), 13, 10
			print str$(ebx), 13, 10
	getkey
	exit
	endif
	; int 3
;	push offset f2sBuffer
;	if 0
;	push dword ptr MyReal8a[4]	; 2*6=12
;	push dword ptr MyReal8a[0]
;	else
;	mov eax, offset MyReal8a	; 10 bytes
;	push [eax+4]
;	push [eax]
;	endif
;	call R8ToStr
;	print offset f2sBuffer, 13, 10
;	nop

;	inkey
	; MsgBox 0, addr f2sBuffer, chr$("Title"), MB_OK
;	exit
	LoopCount	= 1000000-900000*LoopFast
	; LoopCount = 1
	call SpeedBed
	call ShowInfo	; display size and FPU register preservation

	if 0
	; int 3
	push edi
	mov edi, offset MyReal10	; 1+5+n*6+1 = 7+n*6	n=1: 13, 2: 19, 3: 25, 4:31
	mov eax, offset MyReal10
	stosd
	pop edi

	mov edx, offset MyReal10	; 5+1*6 = 11+(n-1)*7	n=1: 11, 2:18, 3:25, 4:32
	mov [edx], offset MyReal10		; 6 bytes
	mov [edx+4], offset MyReal10	; 7 bytes
	mov [edx+8], offset MyReal10	; 7 bytes
	mov [edx+12], offset MyReal10	; 7 bytes

	endif

	mov eax, 12345678
	if f2Test
		call LittleTest
	elseif ShowMacro
	print float$("\n------- New float$ Macro: -------------------\
	\nDivide\tMyReal10\t(=1.2345678e9)\nby\t12345678\
	\t(=1.2e7, in eax)\nadd\t 11.1111   \
	\t(an immediate real)\nResult=\t%f\tok?\
	\n-- This para printed by one line of code! ---\n\n",\
	MyReal10/eax+011.1111)
	print float$('\nMarketing report:\nSales were up %2f% in 2007\n', Sales2007/Sales2006-1*100)
	.data
	tmp1	db 'float$("\nMarketing report:\nSales were up %2f% in 2007\n",'
			db 13, 10, 'Sales2007/Sales2006-1*100)',13, 10, 0
	.code
	print chr$(13, 10, "Code:",13, 10, "print ")
	print offset tmp1
	endif
	if 0		; --------------------------------
	mov eax, 12345678
	print float$("\n------- New float$ mAcro: ---------------------\
	\nDivide\tMyReal10\t(=1.2345678e9)\nby\t12345678\t(=1.2e7, in eax)\nadd\t 11.1111   \
	\t(an immediate real)\nResult=\t%f\n-- This para printed by one line of code! -----\n\n",\
	MyReal10/eax+011.1111)

	; int 3
	; f2s Prec = 8	; for debugging - precision should be under the PROTOs
	mov eax, 12345678
	print float$("\n------- New float$ maCro: ---------------------\nDivide\tMyReal10\t(=1.2345678e9)\nby\t12345678\t(=1.2e7, in eax)\nadd\t 11.1111   \t(an immediate real)\nResult=\t%f\n-- This para printed by one line of code! -----\n\n", MyReal10/eax+011.1111)
	; MsgBox 0, float$("------- New float$ macro: -------------------\nDivide\tMyReal10 (=1.2345678e9)\nby\t12345678\nadd\t11\nResult=\t%f\n-- This para created by ONE line of code! --", MyReal10/12345678+11), "Test float$ macro:", MB_OK
	endif	; --------------------------------
	; print float$("\nThe number %f is far too big", MyReal10)
	; print float$("\nThe number %f is far too small", MyReal10/12345678+11)
	if SpeedTest	; full test
		if UseInit
			print chr$(13, 10, "finit is ON")
		else
			print chr$(13, 10, "finit is OFF")
		endif
		print chr$(9, "Version 1.4, 30 March 2009", 13, 10,"Credits to drizz for the qwtoa algo",13,10,10)

		invoke Sleep, 1000-900*LoopFast

		TestNum 0, MyReal8a	; 0 = FloatToStr ( Masm32 lib )
		TestNum 1, MyReal4a	; 1 = FloatStr ( jj2007 )
		TestNum 1, MyReal8a
		TestNum 1, MyReal10a
		TestNum 3, MyReal8a	; 3 = drizz no FPU algo
		TestNum 2, MyReal10a	; 2 = Raymond Filiatreault's FpuLib
		TestNum 4, MyReal8a	; 4 = crt_sprintf ( C++ )
	if 0
		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8b
		TestNum 1, MyReal4b
		TestNum 1, MyReal8b
		TestNum 1, MyReal10b
		TestNum 3, MyReal8b
		TestNum 2, MyReal10b
		TestNum 4, MyReal8b
	endif
		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8c
		TestNum 1, MyReal4c
		TestNum 1, MyReal8c
		TestNum 1, MyReal10c
		TestNum 3, MyReal8c
		TestNum 2, MyReal10c
		TestNum 4, MyReal8c

		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8d
		TestNum 1, MyReal4d
		TestNum 1, MyReal8d
		TestNum 1, MyReal10d
		TestNum 3, MyReal8d
		TestNum 2, MyReal10d
		TestNum 4, MyReal8d
	if 1
		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8e
		TestNum 1, MyReal4e
		TestNum 1, MyReal8e
		TestNum 1, MyReal10e
		; mov MyInt3, 1
		TestNum 3, MyReal8e
		TestNum 2, MyReal10e
		TestNum 4, MyReal8e

		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8f
		TestNum 1, MyReal4f
		TestNum 1, MyReal8f
		TestNum 1, MyReal10f
		TestNum 3, MyReal8f
		TestNum 2, MyReal10f
		TestNum 4, MyReal8f

		print chr$(13, 10, "---------", 10)	; 0.0 series
		TestNum 0, MyReal8g
		TestNum 1, MyReal4g
		TestNum 1, MyReal8g
		TestNum 1, MyReal10g
		TestNum 3, MyReal8g		; R8ToStr
		TestNum 2, MyReal10g		; Ray
		TestNum 4, MyReal8g		; sprintf
	endif
	elseif MyTest
		LoopCount = 1 ; 00000		; for testing

		; call LoadFPU		; instead of Store8ToFPU
		push edi
		mov edi, 1234512345	; or 2147483647	= 2^31-1
		TestNum 1, edi			; works perfectly

		; TestNum 1, MyInt4		; will not work, mistaken as Real4

		TestNum 1, 12345678	; try an immediate? It works...
		pop edi
	if 0
		TestNum 1, R10_Null
		TestNum 1, R10a
		TestNum 1, R10b
		TestNum 1, R10c
		TestNum 1, R10d
		TestNum 1, R10e
		TestNum 1, R10f
		TestNum 1, R10g
		TestNum 1, R10h
		TestNum 1, R10i
		TestNum 1, R10j
	endif
		print chr$(13, 10, "---------", 10)
		print float$("\na=1234.5, b=123.45, c=113.4567:\na/b+c=%f", @mta/mtb+113.4567)
		print float$("\na=1234.5, b=123.45, c=113 (1.722e8):\na*b*c=%f", @mta*mtb*113)
		print float$("\na=1234.5, b=123.45, c=113:\na/b/c=%f", @mta/mtb/113)
		print float$("\na=1234.5, b=123.45, c=113:\na+b+c=%f", @mta+mtb+113)
		;mov MyInt3, 1	; Pass1
		print float$("\na=1234.5, b=123.45, c=113:\na-b-c=%f", @mta+MyInt3)
		print chr$(13, 10, 10, "---------", 10)

	endif
	print float$("\nPI = %If", MyPI10)	; 3.1415926535897932384626
	getkey
	exit

	; crash
	; MsgBox 0, edx, "ST$ test:", MB_OK

LittleTest proc uses edi
LOCAL MyLocR8:REAL8
	; mov MyLocR8, FP(12345678.9)			; MyReal10=1.2345678e9

if 0
	print float$("\n%f", 123456789012345678.9)
	mov MyInt3, 0

	; print float$("\n%f", 1.234567890e3)		; no activity afterwards
	; print float$("\n%f", 9.87654321e2)
	print chr$("DW: ")
	print float$("\n%f", 1.0000000001e33)	; f2sPrec =
endif

	echo START-----------------

.data
  MyTest10	REAL10	-0.012345678901234567890	; 27 digits can be specified, but only 19.5 are accepted
  My1234R10	REAL10	1.234567890123456789012345
  My1234R8	REAL8	1.234567890123456789012345
  My99R10a	REAL10	9.99999999999999999999e3
  My99R10b	REAL10	9.99999999999999999999e13
  My99R10c	REAL10	9.99999999999999999999e23
  My99R10d	REAL10	9.99999999999999999999e33
  My99R10e	REAL10	1.0000000000000011e3
  My99R10f	REAL10	1.0000000000000011e13
  My99R10g	REAL10	1.0000000000000011e23
  My99R10h	REAL10	1.0000000000000011e33

.code
	call LoadFPU
	print chr$(13,10,"TEST invoke: ")
	print rv(Float2Asc, 0, addr My1234R8)

		print float$("\na=1234.5, b=123.45, c=113.4567:\na/b+c=%f", @mta/mtb+113.4567)
		print float$("\na=1234.5, b=123.45, c=113 (1.722e8):\na*b*c=%f", @mta*mtb*113)
		print float$("\na=1234.5, b=123.45, c=113:\na/b/c=%f", @mta/mtb/113)
		print float$("\na=1234.5, b=123.45, c=113:\na+b+c=%f", @mta+mtb+113)

	print chr$(13, 10, "Test variable precision ", 40,"default: ")
	mov eax, f2sPrec
	print str$(eax)
	print chr$(" digits", 41)
	if SpeedTest eq 0
	mov MyInt3, 1
	print float$("\n999 problem:\t%f", My99R10a)	; 9.99e3, ca. 10000
	print float$("\n999 problem:\t%f", My99R10b)	; 9.99e13
	print float$("\n999 problem:\t%f", My99R10c)	; 9.99e23
	print float$("\n999 problem:\t%f", My99R10d)
	print float$("\n100 problem:\t%f", My99R10e)	; 1.0e3, 1000
	print float$("\n100 problem:\t%f", My99R10f)
	print float$("\n100 problem:\t%f", My99R10g)
	print float$("\n100 problem:\t%f", My99R10h)
	endif
	if 1
	print float$("\n0.0012345:\t%f", 0.0012345678901234567890)
	print float$("\n0.012345:\t%f", 0.012345678901234567890)
	print float$("\n0.12345:\t%f", 0.12345678901234567890)
	; print float$("\n1.2345:      \t%f", 1.2345678901234567890)
	print float$("\n1.2345:      \t%f", My1234R8)
	print float$("\n1.2345 p1: \t%1f", My1234R10)
	print float$("\n1.2345 p2: \t%2f", My1234R10)
	print float$("\n1.2345 p3: \t%3f", My1234R10)
	print float$("\n1.2345 p4: \t%4f", My1234R10)
	print float$("\n1.2345 p5: \t%5f", My1234R10)
	print float$("\n1.2345 p6: \t%6f", My1234R10)
	print float$("\n1.2345 p7: \t%7f", My1234R10)
	print float$("\n1.2345 p8: \t%8f", My1234R10)
	print float$("\n1.2345 p9: \t%9f", My1234R10)
	print float$("\n1.2345 pA: \t%Af", My1234R10)
	print float$("\n1.2345 pB: \t%Bf", My1234R10)
	print float$("\n1.2345 pC: \t%Cf", My1234R10)
	print float$("\n1.2345 pD: \t%Df", My1234R10)
	print float$("\n1.2345 pE: \t%Ef", My1234R10)
	print float$("\n1.2345 pF: \t%Ff", My1234R10)
	print float$("\n1.2345 pG: \t%Gf\t(not officially supported)", My1234R10)	; [url=+1]more[/url]
	print float$("\n1.2345 pH: \t%Hf\t(not officially supported)", My1234R10)
	print float$("\n1.2345 pI: \t%If\t(not officially supported)", My1234R10)
	print float$("\n1.2345 pJ: \t%Jf\t(not officially supported)", My1234R10)	
	; junk: print float$("\n1.2345 pK: \t%Kf\t(not officially supported)", My1234R10)
	print float$("\n12.345:  \t%f", 12.345678901234567890)
	print float$("\n12345.678:\t%f", 12345.678901234567890)
	print float$("\n1.2345e+9:\t%f", 1.2345678901234567890e9)
	print float$("\n1.2345e+12:\t%f", 1.2345678901234567890e12)
	; print float$("\n1.2345e+123:\t%f", 1.2345678901234567890e123)
	print float$("\n1.2345e+123:\t%f", MyReal10e)	;+1.23e+123)
	print float$("\n-1.2345e-123:\t%f\n", MyReal10f)	;-1.23e-123)
	mov MyInt3, 0
	endif

	; print float$("\nx=%f", 9876543210.9876543210)	; 2^32=4294967296

;	print float$("x=\n%f", 9.9999999999e20)

;	print chr$("DW: ")
;	print float$("\n%f", 9.9999999999e20)

;	print chr$("DW: ")
;	print float$("\n%f", 9.99999999e20)

;	print chr$("DW: ")
;	print float$("\n%f", 9.9999999999999999999999999e30)

	mov MyInt3, 0
	echo END-----------------
if 0
	print chr$(13, 10, "ecx: ")
	mov ecx, 123456789
	print float$(ecx)		; instead of dwtoa ;-)
	print chr$(13, 10)

	; invoke Float2Asc, chr$("\nA test: %f\n\n"), addr MyReal8
	; MsgBox 0, eax, "Float test:", MB_OK

	print rv(Float2Asc, chr$("\nA test: %f\n\n"), offset MyReal8)
	print rv(Float2Asc, 0, offset MyReal8)


	; MsgBox 0, rv(Float2Asc, chr$("A test: %f"), offset MyReal8d), "Test", MB_OK

	ffree st(7)
	push 2000
	fild dword ptr [esp]		; push an integer (reg or immediate)
	pop eax
	lea edx, MyLocR8
	fstp REAL8 ptr [edx]
	mov edi, 12345678
	mov MyInt4, edi
	; mov MyInt3, 1
	print chr$(13, 10, "MyInt4 test: ")
	print float$(MyInt4)		; instead of dwtoa ;-)
	mov ch, 2	; ax and dx would be trashed by MyInt4 or immediate integers
	print float$("\nfloat$, expected 2222.2222:\n%f", MyReal10 / edi + 011.1111 * ch + MyLocR8)
	print rv(Float2Asc, chr$("\nA test: %f\n\n"), offset MyReal8d)
	print rv(Float2Asc, 0, offset MyReal8d)
	; MsgBox 0, float$("Sales were up %2 % in 2007", Sales2007/Sales2006-1*100), "Marketing says:", MB_OK
endif
	ret
LittleTest endp

SpeedBed proc
	print chr$(13, 10)
	invoke Sleep, 200

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		if 1
			nop
			mov eax, float$(MyReal8a)
			nop
			mov eax, float$(MyReal8a)
			nop
			mov eax, float$(MyReal8a)
			nop
			mov eax, float$(MyReal8a)
		else
			nop
			mov eax, 12345678
			mov eax, float$(eax)
			nop
			mov eax, float$(MyReal4d)
			nop
			mov eax, float$(MyReal8d)
			nop
			mov eax, float$(MyReal10d)
		endif

	counter_end
	sar eax, 2
	print ustr$(eax), " cycles for 4*float$    ", 9
	print offset f2sBuffer, 13, 10
	if SpeedTest
	invoke Sleep, 200
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		nop
		push offset f2sBuffer
		mov eax, offset MyReal8a
		push [eax+4]
		push [eax]
		call R8ToStr
		nop
		push offset f2sBuffer
		mov eax, offset MyReal8a
		push [eax+4]
		push [eax]
		call R8ToStr
		nop
		push offset f2sBuffer
		mov eax, offset MyReal8a
		push [eax+4]
		push [eax]
		call R8ToStr
		nop
		push offset f2sBuffer
		mov eax, offset MyReal8a
		push [eax+4]
		push [eax]
		call R8ToStr
	counter_end
	sar eax, 2
	print ustr$(eax), " cycles for 4*R8ToStr   ", 9
	print offset f2sBuffer, 13, 10

	invoke Sleep, 200
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
			nop
			invoke FloatToStrX, MyReal8d, addr f2sBuffer
			nop
			invoke FloatToStrX, MyReal8d, addr f2sBuffer
			nop
			invoke FloatToStrX, MyReal8d, addr f2sBuffer
			nop
			invoke FloatToStrX, MyReal8d, addr f2sBuffer
	counter_end
	sar eax, 2
	print ustr$(eax), " cycles for 4*FloatToStr", 9
	print offset f2sBuffer, 13, 10, 10
	; print chr$("float$: reg32, Real4, Real8, Real10",13,10,"MasmLib FloatToStr: 4*Real8",13,10,10)
	endif
	ret
SpeedBed endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF
f2sGL2:

LoadFPU proc						; test: load all 8 FPU regs
		if UseInit
			finit
		endif
		xor eax, eax
		mov ecx, offset f2sP10	; clear the first table entry to
		mov [ecx], eax			; signal it has to be created again
		mov ecx, 8
@@:		push ecx
		fild dword ptr [esp]
		pop ecx
		dec ecx
		jne @B
;		pushad
;		print chr$(13, 10, "Init", 13,10)
;		popad
		ret
LoadFPU endp

ReLoad proc
	mov edx, offset f2sP10
	xor eax, eax
	mov [edx], eax		; force reload
	ret
ReLoad endp

ShowInfo proc
	print chr$(13, 10, 10, "Code sizes and FPU register preservation:")
	print chr$(13, 10, "float$   ",9,"size=")
	mov eax, offset f2sGL2
	sub eax, offset Float2Asc
	add eax, 28		; data section
	print ustr$(eax)
	print chr$(", all ST regs preserved")

	print chr$(13, 10, "FloatToStr", 9,"size=")
	mov eax, offset f2sGL0
	sub eax, offset FloatToStrX
	add eax, offset tenX
	sub eax, offset ten
	print ustr$(eax)
	print chr$(", ST 6-8 trashed")

	print chr$(13, 10, "R8ToStr  ",9,"size=")
	mov eax, offset f2sGL3-R8ToStr
	add eax, 28		; data section
	print ustr$(eax)
	print chr$(", no ST regs used")

	print chr$(13, 10, "Ray's lib",9,"size=700")
	print chr$(", all ST regs preserved")

	print chr$(13, 10, "crt sprintf",9,"size=???")
	print chr$(", all ST regs preserved", 13, 10)
	ret
ShowInfo endp

; SEEEEEEEEEEEFFFFFFFFFFFFFFFFFFFF FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
; 10000000000000000000000000000000 00000000000000000000000000000000
; 01111111111100000000000000000000 00000000000000000000000000000000
; 00000000000011111111111111111111 11111111111111111111111111111111
;            100000000000000000000 00000000000000000000000000000000 ; implied

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

R8_BIAS equ 1023
R8_MANT equ 52

R8ToStr proc r8:REAL8, lpBuffer:PTR

	push ebp
	push esi
	push edi
	push ebx
	locals = 32+3*4
	tmpbuff equ <[esp]>
	iTrail equ <dword ptr [esp+32]>
	iExp equ <dword ptr [esp+32+4]>
	nSign equ <dword ptr [esp+32+4+4]>
	add esp,-locals

	mov ecx,10000000000000000000000000000000b
	mov ebx,[esp+2*4][4*4][locals]
	mov esi,[esp+1*4][4*4][locals]	
	and ecx,ebx; sign bit
	and ebx,not 10000000000000000000000000000000b
	mov nSign,ecx
	mov edi,ebx
	shr ebx,20; 01111111111100000000000000000000
	and edi,00000000000011111111111111111111b
	cmp ebx,11111111111b
	je @@_NaN_Infinity
	mov eax,esi
	or eax,edi
	or eax,ebx
	jz @@Zero
	sub ebx,R8_BIAS; exponent
	or  edi,00000000000100000000000000000000b; high 20 bits + 1 implied
	xor ebp,ebp
	mov iExp,ebx
	;; 52bits in edi::esi
	.if sdword ptr ebx > 63
		shld edi,esi,63-R8_MANT
		shl esi,63-R8_MANT
		.repeat
			call __div10
			; mod 10
			lea ecx,[eax*4+eax]
			add ecx,ecx
			sub esi,ecx

			bsr ecx,edx
			neg ecx
			add ecx,31
			shld edx,eax,cl
			shl eax,cl

			mov ebx,iExp
			sub ebx,ecx
			
			or esi,eax
			mov edi,edx
			
			mov iExp,ebx
			add ebp,1
		.until sdword ptr ebx <= 63
		mov ecx,63
		sub ecx,ebx
		shrd esi,edi,cl
		shr edi,cl
	.else
		.while sdword ptr ebx < R8_MANT
			.while ! (edi & 0F0000000h)
				mov eax,esi
				mov edx,edi
				shld edi,esi,2
				shl esi,2
				add esi,eax
				adc edi,edx
				add ebx,1
				dec ebp
			.endw
			bsr ecx,edi
			sub ecx,31-4
			sbb edx,edx
			not edx
			and ecx,edx
			shrd esi,edi,cl
			shr edi,cl
			add ebx,ecx
		.endw
		lea ecx,[ebx-R8_MANT]
		shld edi,esi,cl
		shl esi,cl
	.endif
;	mov edx,nSign
;	pushad
;	shr edx,1
;	sbb edx,edx
;	and edx,'-'-'+'
;	add edx,'+'
;	invoke printf,T("%c%I64u.0e%i",13,10),edx,edi::esi,ebp
;	popad
	; job done, now just the hard part - formating
	
	;; adjust number to 16 digits 2386F26FC0FFFFh
	.while edi >= 2386F2h; LOW = 6FC0FFFF
		.break .if edi == 2386F2h && esi < 6FC0FFFFh
		call __div10
		mov esi,eax
		mov edi,edx
		add ebp,1;; increase exponent
	.endw

	;; round it if needed (if 16 digit) 38D7EA4C67FFFh
	.if edi>=38D7Eh;A4C67FFF
		.if ! (edi == 38D7Eh && esi < 0A4C67FFFh)
			add esi,5
			adc edi,0
			call __div10
			add ebp,1; increase exponent
			mov esi,eax
			mov edi,edx
		.endif		
	.endif
	
	mov iExp,ebp
	;; trailing zero count
	xor ebp,ebp
	jmp @F
	.repeat
		mov esi,eax
		mov edi,edx
		add ebp,1
	@@:	call __div10
		lea ecx,[eax*4+eax]
		neg ecx
		add ecx,ecx
		add ecx,esi
	.until !zero?
	mov iTrail,ebp
	xor ebp,ebp
	jmp @F
	.repeat
		call __div10
	@@:	lea ecx,[eax*4+eax]
		neg ecx
		lea ecx,[ecx*2+esi+'0']
		mov tmpbuff[ebp],cl
		add ebp,1
		mov esi,eax
		mov edi,edx
		or eax,edx
	.until zero?

	mov ecx,nSign
	mov esi,[esp+3*4][4*4][locals]	
	add ecx,ecx
	mov edx,'-'
	mov edi,iExp; exp
	sbb ecx,ecx
	and edx,ecx
	mov [esi],dl		; GPF
	sub esi,ecx

	add edi,iTrail
	xchg esi,ebp
	.if zero?;; exponent is 0
		.repeat
			mov al,tmpbuff[esi-1]
			mov [ebp],al
			add ebp,1
			sub esi,1
		.until zero?
		
	.elseif (sdword ptr edi >=-15 && sdword ptr edi < 0)
		;; check for format without exp
		add edi,esi
		.if sdword ptr edi <= 0
			mov [ebp],word ptr '.0'
			add ebp,2
			.while sdword ptr edi < 0
				mov [ebp],byte ptr '0'
				add ebp,1
				add edi,1
			.endw
			.repeat
				mov al,tmpbuff[esi-1]
				mov [ebp],al
				add ebp,1
				sub esi,1
			.until zero?
		.else
			.repeat
				mov al,tmpbuff[esi-1]
				mov [ebp],al
				add ebp,1
				sub edi,1
				.if zero?
					mov [ebp],byte ptr '.'
					add ebp,1
				.endif
				sub esi,1
			.until zero?
		.endif
	.else
		;
		mov al,tmpbuff[esi-1]
		mov [ebp],al
		add ebp,1
		sub esi,1
		jz @F

		mov [ebp],byte ptr '.'
		add ebp,1
		.repeat
			mov al,tmpbuff[esi-1]
			mov [ebp],al
			add ebp,1
			add edi,1
			sub esi,1
		.until zero?
@@:
		mov [ebp],byte ptr 'e'
		add ebp,1

		mov eax,edi
		
		cdq
		and edx,'-'-'+'
		add edx,'+'
		mov [ebp],dl
		add ebp,1
		
		; abs
		cdq
		xor eax,edx
		sub eax,edx
		mov edi,0CCCCCCCDh; magic
		mov ecx,eax
		mul edi
		shr edx,3
		lea ebx,[edx*4+edx]
		neg ebx
		lea ebx,[ebx*2+ecx+'0']
		mov eax,edx
		.if edx
			mov ecx,eax
			mul edi
			shr edx,3
			lea esi,[edx*4+edx]
			neg esi
			lea esi,[esi*2+ecx+'0']
			mov eax,edx
			.if edx
				mov ecx,eax
				mul edi
				shr edx,3
				lea eax,[edx*4+edx]
				neg eax
				lea eax,[eax*2+ecx+'0']
				mov [ebp],al
				add ebp,1
			.endif
			mov eax,esi
			mov [ebp],al
			add ebp,1
		.endif
		mov [ebp],bl
		add ebp,1

	.endif

@@Done:	
	mov byte ptr [ebp],0
	mov eax,ebp
	sub eax,[esp+3*4][4*4][locals]	
	
	add esp,locals
	pop ebx
	pop edi
	pop esi
	pop ebp
	ret 3*4
	
@@_NaN_Infinity:
	mov ecx,nSign
	mov ebp,[esp+3*4][4*4][locals]
	add ecx,ecx
	mov edx,'-'
	sbb ecx,ecx
	and edx,ecx
	mov [ebp],dl
	sub ebp,ecx
	mov dword ptr [ebp],'#.1'	
	mov eax,edi
	or eax,esi
	.if !eax
		mov eax,'FNI'
		mov [ebp+3],eax	
		add ebp,6
	.elseif edi & 10000000000000000000b
		mov eax,'NANQ'
		mov [ebp+3],eax	
		add ebp,7
	.elseif ! (edi & 10000000000000000000b)
		mov eax,'NANS'
		mov [ebp+3],eax	
		add ebp,7
	.else
		mov eax,'DNI'
		mov [ebp+3],eax	
		add ebp,6
	.endif
	jmp @@Done

@@_Subnormal:
	mov ebp,[esp+3*4][4*4][locals]
	mov dword ptr [ebp],'!RRE'	
	add ebp,4
	jmp @@Done

@@Zero:
	mov ebp,[esp+3*4][4*4][locals]
	mov byte ptr [ebp],'0'	
	add ebp,1
	jmp @@Done

	;; div <edi::esi> by 10
	;; ret <edx::eax> 
	align 8
__div10:
	; div 10
	mov eax,0CCCCCCCDh; = b0
	mul esi; get a0*b0 = d1:d0
	mov ecx,edx;d1
	mov eax,0CCCCCCCDh; = b0
	xor ebx,ebx
	mul edi; get a1*b0 = e1:e0
	add ecx,eax;e0
	adc ebx,edx;e1
	mov eax,0CCCCCCCCh; =b1
	mul esi; get a0*b1 = f1:f0
	add ecx,eax;f0
	adc ebx,edx;f1
	mov ecx,0
	mov eax,0CCCCCCCCh; =b1
	adc ecx,ecx
	mul edi; get a1*b1 = g1:g0
	add eax,ebx;g0
	adc edx,ecx;g1
	shrd eax,edx,3
	shr edx,3;;------ quotient in edx::eax
	retn

R8ToStr endp 
f2sGL3:

F2sRay proc
  if 0
	ffree st(7)
	fld REAL8 ptr [edx]		; load from mem, 3 cycles - any chance to determine size at runtime?
  endif
  invoke FpuFLtoA, edx, 6, offset f2sBuffer, SRC1_REAL or SRC2_DIMM ; or STR_SCI
  ret
F2sRay endp

FS_sprintf proc uses esi f2sNum:DWORD, f2sBuf:DWORD
	INVOKE crt_sprintf, ADDR f2sBuffer, ADDR sprintFormat, REAL8 PTR [eax]
	mov edx, offset f2sBuffer
  ret
FS_sprintf endp

if 1
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
CopyMem proc lpSource:DWORD,lpDest:DWORD,bcount:DWORD
;--------------------------------------- adapted from GeneSys, this version 32 bytes
;    cld                                 ; Clear direction flag
    push    esi
    push    edi

	mov esi, [esp+12]					; lpSource in ESI
	mov edi, [esp+16]					; Destination address in EDI
    mov ecx, [esp+20]					; Byte count to copy in ECX
	push	ecx
    shr     ecx, 2                      ; Divide count by 4
    rep     movsd                       ; Copy DWORD size blocks
	pop		ecx
;	 mov     ecx, bcount                 ; Reload byte count
    and     ecx, 3                      ; Calculate remainder
    rep     movsb                       ; Copy tail
    pop     edi
    pop     esi
    ret 3*4
;---------------------------------------
CopyMem endp
ct1:

align 4
CopyPop proc lpSource:DWORD,lpDest:DWORD,bcount:DWORD
;--------------------------------------- jj2007 ----------
    push esi
    push edi
	mov eax, esp
	add esp, 4*4
	pop edi				; Destination address in EDI
	pop ecx				; Byte count to copy in ECX
	mov esp, [eax+12]	; Source address into fake stack pointer
	mov edx, ecx		; counter
	and edx, 11111111111111111111111111111100b
	je LessThan4

@@:	pop [edi]
	add edi, 4
	sub edx, 4
	jne @B

LessThan4:
	and ecx, 3			; Calculate remainder
	mov esi, esp
	rep movsb			; Copy tail
	mov esp, eax		; restore stack
	pop edi
	pop esi
	ret 3*4
;---------------------------------------
CopyPop endp
ct2:
OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

Dummy proc
  push esi
  pop esi
  ret
Dummy endp
endif
; Tim N. Roberts.


; These are bits in the FP status word.

FP_LESSTHAN	equ	01h
FP_EQUALTO	equ	40h

	.data

; I'd rather this was local to the procedure, but masm doesn't do 
; local arrays correctly.

szTemp	db	18 dup (0)

	.code

PowerOf10	proto

;ten	dq	10.0
ten7	dq	1.0e6
;ten17	dq	1.0e17
;rounder	dq	5.0e10


; Convert a floating point register to ASCII.  For internal use.
; The result always has exactly 18 digits, with zero padding on the
; left if required.
;
; Entry:	ST(0) = a number to convert, 0 <= ST(0) < 1E19.
;		szTemp = an 18-character buffer.
;
; Exit:		szTemp = the converted result.

FloatToBCD	PROC	public uses esi edi

    sub esp, 10

	; The fbstp instruction converts the top of the stack to a
	; packed BCD form in ten bytes, with two digits per byte.  The top 
	; byte has the sign, which we ignore.

 	; fbstp [esp]
 	fbstp REAL10 ptr [esp]

	; Now we need to unpack the BCD to ASCII.

    lea esi, [esp+8]
    lea edi, [szTemp]
    mov ecx, 9

    .REPEAT
	mov al, [esi]          ; .... .... AAAA BBBB
	dec esi
	rol ax, 12             ; BBBB .... .... AAAA
	rol ah, 4              ; .... BBBB .... AAAA
	and ax, 0f0fh          ; 0000 BBBB 0000 AAAA
	add ax, 3030h          ; 3B3A
	mov [edi], ax
	add edi, 2
	dec ecx
    .UNTIL ZERO?

    add esp, 10
    ret

FloatToBCD	ENDP

; Convert a double precision number to a string.
;
; Entry:	fpin = 8-byte double to convert
;		szDbl = character buffer
;
; Exit:		szDbl = converted value
;
; szDbl should be at least 19 bytes long.
;		

FloatToStrX	PROC	stdcall public USES esi edi, fpin: QWORD, szDbl: PTR CHAR
    LOCAL	i2Exp: DWORD
    LOCAL	stat: WORD
    LOCAL	mystat: WORD

; Special case zero.  fxtract fails for zero.
	
    mov edi, [szDbl]

    .if	(dword ptr [fpin] == 0) && (dword ptr [fpin][4] == 0)
      mov byte ptr [edi], '0'
      mov byte ptr [edi][1], 0
      ret
    .endif

; Check for a negative number.

    .if	(sdword ptr [fpin][4] < 0)
      and byte ptr [fpin][7], 07fh	; change to positive
      mov byte ptr [edi], '-'		; store a minus sign
      inc edi
    .endif

; Initialize the floating point unit and load our value onto the stack.

    fclex
    fstcw [stat]
    mov [mystat], 027fh
    fldcw [mystat]

    fld [fpin]
    fld st(0)

; Compute the closest power of 10 below the number.  We can't get an
; exact value because of rounding.  We could get close by adding in
; log10(mantissa), but it still wouldn't be exact.  Since we'll have to
; check the result anyway, it's silly to waste cycles worrying about
; the mantissa.
;
; The exponent is basically log2(fpin).  Those of you who remember
; algebra realize that log2(fpin) x log10(2) = log10(fpin), which is
; what we want.

    fxtract			; ST=> mantissa, exponent, fpin
    fstp st(0)			; drop the mantissa
    fldlg2			; push log10(2)
    fmulp st(1), st		; ST = log10(fpin), fpin
    fistp [i2Exp]		; ST = fpin

; An 8-byte double can carry almost 16 digits of precision.  Actually, it's
; 15.9 digits, so some numbers close to 1E17 will be wrong in the bottom
; digit.  If this is a concern, change the '16' to a '15'.
;
; A 10-byte double can carry almost 19 digits, but fbstp only stores the
; guaranteed 18.  If you're doing 10-byte doubles, change the '16' to '18'.

    .IF	([i2Exp] < 16)
      fld st(0)			; ST = fpin, fpin
      frndint			; ST = int(fpin), fpin
      fcomp st(1)		; ST = fpin, status set
      fstsw ax
      .IF (ah & FP_EQUALTO)	; if EQUAL

; We have an integer!  Lucky day.  Go convert it into a temp buffer.

	call FloatToBCD

	mov eax, 17
	mov ecx, [i2Exp]
	sub eax, ecx
	inc ecx
	lea esi, [szTemp][eax]

; The off-by-one order of magnitude problem below can hit us here.  
; We just trim off the possible leading zero.

	.IF (byte ptr [esi] == '0')
	  inc esi
	  dec ecx
	.ENDIF

; Copy the rest of the converted BCD value to our buffer.

	rep movsb
	jmp ftsExit

      .ENDIF
    .ENDIF

; We use the format [-]d.ddddddE+ddd.  That means we only need a maximum
; of 7 decimal places.  Let's have fbstp do our rounding for us.

    mov eax, 6
    sub eax, [i2Exp]	; adjust exponent to 7
    call PowerOf10X

; Either we have exactly 7 digits, or we have exactly 6 digits.  We can
; detect that condition and adjust now.

    fcom [ten7]
    ; x0nnnn00 means top of stack > ten7
    ; x0nnnn01 means top of stack < ten7
    ; x1nnnn00 means top of stack = ten7
    fstsw ax
    .IF (ah & 1)
      fmul [ten]
      dec i2Exp
    .ENDIF

; Go convert to BCD.

    call FloatToBCD

    lea esi, [szTemp+11]	; point to converted buffer

; If the exponent is between -1 and 6, we can express this as a number
; without scientific notation.

    mov ecx, i2Exp
    .IF (SDWORD PTR ecx >= -1) && (SDWORD PTR ecx <= 6)

; We need to copy ecx+1 digits, then a decimal point (maybe), then 
; the remaining 6-ecx digits.  If exponent is 0, add a leading 0.

      .IF (SDWORD PTR ecx == -1)
	mov byte ptr [edi], '0'
	inc edi
      .ENDIF

      inc ecx
      rep movsb
      mov byte ptr [edi], '.'
      inc edi
      mov ecx, 6
      sub ecx, [i2Exp]
      rep movsb

; Trim off trailing zeros.

      .WHILE (byte ptr [edi-1] == '0')
	dec edi
      .ENDW

; If we cleared out all the decimal digits, kill the decimal point, too.

      .IF (byte ptr [edi-1] == '.')
	dec edi
      .ENDIF

; That's it.

      jmp ftsExit

    .ENDIF


; Now convert this to a standard, usable format.  If needed, a minus
; sign is already present in the outgoing buffer, and edi already points
; past it.

    movsb				; copy the first digit
    mov byte ptr [edi], '.'		; plop in a decimal point
    inc edi
    movsd				; copy four more digits
    movsw				; copy two more digits

if 0

; The printf %g specified trims off trailing zeros here.  I dislike
; this, so I've disabled it.  Comment out the if 0 and endif if you
; want this.

    .WHILE (byte ptr [edi][-1] == '0')
      dec edi
    .ENDW
endif

; Shove in the exponent.  If you support 10-byte reals, remember to
; allow 4 digits for the exponent.

    mov byte ptr [edi], 'e'	; start the exponent
    mov eax, [i2Exp]
    .IF (sdword ptr eax < 0)	; plop in the exponent sign
      mov byte ptr [edi][1], '-'
      neg eax
    .ELSE
      mov byte ptr [edi][1], '+'
    .ENDIF

    mov ecx, 10

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][4], dl	; shove in the ones exponent digit

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][3], dl	; shove in the tens exponent digit

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][2], dl	; shove in the hundreds exponent digit

    add edi, 5		; point to terminator

; Clean up and go home.

ftsExit:
    mov byte ptr [edi], 0
    fldcw [stat]		; restore control word
    fwait

    ret
FloatToStrX	ENDP

PowerOf10X	PROC	public

    mov ecx, eax
    .IF	(SDWORD PTR eax < 0)
	neg eax
    .ENDIF

    fld1

    mov dl, al
    and edx, 0fh
    .IF	(!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_1[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    mov dl, al
    shr dl, 4
    and edx, 0fh
    .IF (!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_16[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    mov dl, ah
    and edx, 1fh
    .IF (!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_256[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    .IF (SDWORD PTR ecx < 0)
	fdivp st(1), st
    .ELSE
	fmulp st(1), st
    .ENDIF

    ret

PowerOf10X	ENDP
f2sGL0:

	invoke MessageBox, 0, chr$("Gotcha!"), chr$("Title"), MB_OK
	exit

; 

end start

OPT_Assembler	JWasm		; would not work with JWasm, December 2008, see [url=+0]here[/url]
OPT_Linker	polink
OPT_DebugL	/merge:.text=.data
OPT_Icon	Calc
OPT_WAIT	0
OPT_Susy	CONSOLE
OPT_Tmp2Asm	1
